config/config/urls.py
from django.contrib import admin
from django.urls import path, include  # Import this function
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    # Main app
    path('', include('crudj.urls')),
    #authentication app
    path('users/', include('users.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

config/crudj/urls.py
# photoapp/urls.py
from django.urls import path
# Empty patterns
from .views import (
    PhotoListView,
    PhotoTagListView,
    PhotoDetailView,
    PhotoCreateView,
    PhotoUpdateView,
    PhotoDeleteView
)

app_name = 'photo'

urlpatterns = [
    path('', PhotoListView.as_view(), name='list'),
    path('tag/<slug:tag>/', PhotoTagListView.as_view(), name='tag'),
    path('photo/<int:pk>/', PhotoDetailView.as_view(), name='detail'),
    path('photo/create/', PhotoCreateView.as_view(), name='create'),
    path('photo/<int:pk>/update/', PhotoUpdateView.as_view(), name='update'),
    path('photo/<int:pk>/delete/', PhotoDeleteView.as_view(), name='delete'),

]

config/users/urls.py
from django.urls import path

from django.contrib.auth.views import LogoutView

from .views import SignUpView, CustomLoginView

app_name = 'user'

urlpatterns = [
    path('signup/', SignUpView.as_view(), name='signup'),
    path('login/', CustomLoginView.as_view(), name='login'),
    path('logout/', LogoutView.as_view(), name='logout'),
]

config/crudj/models.py
from django.db import models

from django.contrib.auth import get_user_model

from taggit.managers import TaggableManager

# Create your models here


class photo(models.Model):
    title = models.CharField(max_length=45)
    description = models.CharField(max_length=250)
    created = models.DateTimeField(auto_now_add=True)
    image = models.ImageField(upload_to='photos/')
    submitter = models.ForeignKey(get_user_model(), on_delete=models.CASCADE)
    tags = TaggableManager()

    def __str__(self):
        return self.title

config/users/models.py
from django.db import models

# Create your models here.

config/crudj/views.py
from django.shortcuts import render

from django.shortcuts import get_object_or_404

from django.core.exceptions import PermissionDenied
from django.urls.base import set_urlconf

from django.views.generic import ListView, DetailView, CreateView, UpdateView, DeleteView

from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin

from django.urls import reverse_lazy

from .models import photo

# Create your views here.


class PhotoListView(ListView):
    model = photo
    template_name = 'photoapp/list.html'
    context_object_name = 'photos'


class PhotoTagListView(PhotoListView):
    template_name = 'photoapp/taglist.html'

    def get_tag(self):
        return self.kwargs.get('tag')

    def get_queryset(self):
        return self.model.objects.filter(tags__slug=self.get_tag())

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["tag"] = self.get_tag()
        return context


class PhotoDetailView(DetailView):
    model = photo
    template_name = 'photoapp/detail.html'
    context_object_name = 'photo'


class PhotoCreateView(LoginRequiredMixin, CreateView):
    model = photo
    fields = ['title', 'description', 'image', 'tags']
    template_name = 'photoapp/create.html'
    success_url = reverse_lazy('photo:list')

    def form_valid(self, form):
        form.instance.submitter = self.request.user
        return super().form_valid(form)


class UserIsSubmitter(UserPassesTestMixin):
    def get_photo(self):
        return get_object_or_404(photo, pk=self.kwargs.get('pk'))

    def test_func(self):
        if self.request.user.is_authenticated:
            return self.request.user == self.get_photo().submitter
        else:
            raise PermissionDenied('Sorry you are not allowed here')


class PhotoUpdateView(UserIsSubmitter, UpdateView):
    template_name = 'photoapp/update.html'
    model = photo
    fields = ['title', 'description', 'tags']
    success_url = reverse_lazy('photo:list')


class PhotoDeleteView(UserIsSubmitter, DeleteView):
    template_name = 'photoapp/delete.html'
    model = photo
    success_url = reverse_lazy('photo:list')

config/users/views.py
from django.shortcuts import render

from django.views.generic import CreateView

from django.contrib.auth import authenticate, login

from django.contrib.auth.forms import UserCreationForm

from django.urls import reverse_lazy

from django.contrib.auth.views import LoginView

# Create your views here.


class SignUpView(CreateView):
    template_name = 'users/signup.html'
    form_class = UserCreationForm
    success_url = reverse_lazy('photo:list')

    def form_valid(self, form):
        to_return = super().form_valid(form)

        user = authenticate(
            username=form.cleaned_data["username"],
            password=form.cleaned_data["password1"],
        )

        login(self.request, user)

        return to_return


class CustomLoginView(LoginView):
    template_name = 'users/login.html'

config/crudj/templates/photoapp/create.html
<!-- photoapp/templates/photoapp/create.html -->
{% extends 'base.html' %}
    {% load crispy_forms_tags %}

        {% block body %}
            <div class="mx-auto">
                <h1 class="mt-3 text-center">Add photo</h1>
            </div>
            <div class="form-group">
                <form action="" method="post" enctype="multipart/form-data">
                    {% csrf_token %}
                    {{ form|crispy }}
                    <button type="submit" class="btn btn-success mb-3">Add Photo</button>
                </form>
            </div>
{% endblock body %}

config/crudj/templates/photoapp/delete.html
<!-- photoapp/templates/photoapp/delete.html -->
{% extends 'base.html' %} 

{% block body %}
<div class="form-group mx-auto">
  <h2 class="text-center">
    You are going to <span class="text-danger">delete</span>: "<i
      >{{ photo }}</i
    >
    "
  </h2>
  <p class="text-center">Are you sure, you want to delete the photo ?</p>
  <div class="form-group">
    <form
      action=""
      method="post"
      class="d-flex flex-column align-items-center justify-content-center"
    >
      {% csrf_token %}
      <div class="row">
        <div class="col">
          <a href="{% url 'photo:detail' photo.id %}" class="btn btn-primary"
            >Cancel</a
          >
        </div>
        <div class="col">
          <button type="submit" class="btn btn-danger">Delete</button>
        </div>
      </div>
      <p>This action is irreversible</p>
    </form>
  </div>
</div>

{% endblock body %}

config/crudj/templates/photoapp/detail.html
<!-- photoapp/templates/photoapp/detail.html -->
{% extends 'base.html' %} 

    {% block body %}
    <div class="mx-auto">
        <h1 class="text-center">{{ photo.title }}</h1>
            <p class="text-center fw-light">Uploaded on: {{photo.created}} <br> By {{photo.submitter.username}}</p>
            {% if user == photo.submitter %}
                <p class="text-center">
                    <span><a href="{% url 'photo:update' photo.id %}" class="text-primary px-2">Update</a></span>
                    <span><a href="{% url 'photo:delete' photo.id %}" class="text-danger px-2">Delete</a></span>
                </p>
            {% endif %}
    </div>
    <div class="row pb-5">
        <div class="col-md-8">
            <img src="{{photo.image.url}}" alt="" width="100%" />
        </div>
        <div class="col-md-4">
            <h4>More about this photo:</h4>
                <ul class="list-group list-group-horizontal-lg list-unstyled py-4">
                    {% for tag in photo.tags.all %}
                        <li><a href="{% url 'photo:tag' tag.slug %}" class="btn btn-sm list-group-item list-group-item-primary">{{tag.name}}</a></li>
                    {% endfor %}
                </ul>
            <p>{{ photo.description }}</p>
        </div>
    </div>

    {% endblock body %}

config/crudj/templates/photoapp/list.html
<!-- crudj/templates/photoapp/list.html-->
{% extends 'base.html' %}

{% block body %}
    <div. class="row">
        {% for photo in photos %}
        <div class="col-lg-3 col-md-4 col-xs-6">
            <a href="{% url 'photo:detail' photo.id %}" class="d-block mb-4 h-100">
                <img src="{{photo.image.url}}" class="img-fluid rounded" alt="{{photo.title}}" />
            </a>
        </div>
        {% endfor %}
    </div.
{% endblock body %}

config/crudj/templates/photoapp/taglist.html
<!-- photoapp/templates/photoapp/taglist.html -->
{% extends 'photoapp/list.html' %}

{% block body %}
    <div class="alert alert-primary">
        <h2 class="text-center">Photos with the tag {{tag}}</h2>
    </div>
{{ block.super }}
{% endblock body %}

config/crudj/templates/photoapp/update.html
<!-- photoapp/templates/photoapp/update.html -->
{% extends 'base.html' %}
{% load crispy_forms_tags %}

{% block body %}
<div class="mx-auto">
  <h1 class="mt-3 text-center">Edit photo {{photo}}</h1>
</div>
<div class="form-group">
  <form action="" method="post" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form|crispy }}
    <button type="submit" class="btn btn-success mb-3">Edit Photo</button>
  </form>
</div>
{% endblock body %}

config/templates/base.html
<!-- templates/base.html -->
<!DOCTYPE html>
<html lang='en'>
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Django CRUD app for sharing images</title>
        <link
            href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0/dist/css/bootstrap.min.css"
            rel="stylesheet"
            integrity="sha384-wEmeIV1mKuiNpC+IOBjI7aAzPcEZeedi5yW5f2yOq55WWLwNGmvvx4Um1vskeMj0"
            crossorigin="anonymous"
        />

        <link
            rel="stylesheet"
            href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
            integrity="sha512-iBBXm8fW90+nuLcSKlbmrPcLa0OT92xO1BIsZ+ywDWZCvqsWgccV3gFoRBv0z+8dLJgyAHIhR35VZc2oM/gI1w=="
            crossorigin="anonymous"
        />
    </head>

    <body>
        {% include 'navbar.html'%}

        <div class="container mt-4">
        {% block body%}

        {% endblock body%}

        <script
            src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0/dist/js/bootstrap.bundle.min.js"
            integrity="sha384-p34f1UUtsS3wqzfto5wAAmdvj+osOnFyQFpp4Ua3gs/ZVWx6oOypYoCJhGGScy+8"
            crossorigin="anonymous"
        ></script>
    </body>
</html>

config/templates/navbar.html
<!-- templates/navbar.html-->
<nav class="navbar navbar-expand-md navbar-dark bg-dark">
    <div calss="container-fluid">
        <div calss="container-fluid">
        <a class="navbar-brand" href="{% url 'photo:list' %}">Photo CRUD App</a>
        <button
            class="navbar-toggler"
            type="button"
            data-bs-toggle="collapse"
            data-bs-target="#navbarTogglerDemo02"
            aria-controls="navbarTogglerDemo02"
            aria-expanded="false"
            aria-label="Toggle navigation"
        >
        <span class="navbar-toggler-icon"></span>
        </button>
        </div>
        <div
            class="collapse navbar-collapse flex-row-reverse"
            id="navbarTogglerDemo02">
        <ul class="navbar-nav" style="text-align: right">
        {% if user.is_authenticated %}
        <li class="nav-item">
            <a class="nav-link active" href="{% url 'photo:create' %}">Add a photo</a>
        </li>
        <li class="nav-item">
            <a class="nav-link active" href="#">Hi {{user.username}}</a>
        </li>
        {% else %}
        <li class="nav-item" align="right">
            <a href="{% url 'user:login' %}" class="btn btn-sm btn-danger">Sign In</a>
        </li>
        {% endif %}
        </ul>
        </div>
    </div>
</nav>

config/users/templates/users/login.html
<!-- users/templates/users/login.html -->
{% extends 'base.html' %} 
{% load crispy_forms_tags %}

{% block body %}

<div class="mx-auto">
  <div class="form-group">
    <form action="" method="post">
      {% csrf_token %} 
      {{ form|crispy }}
      <button type="submit" class="btn btn-danger w-100 my-3">Sign in</button>
    </form>
  </div>
  {% comment %}  Already Registered {% endcomment %}
  <div class="text-center w-100">
    <p class="text-muted font-weight-bold">
      Don't have an account?
      <a href="{% url 'user:signup' %}" class="text-primary ml-2">Create account</a>
    </p>
  </div>
</div>
{% endblock body %}

config/users/templates/users/signup.html
<!-- users/templates/users/signup.html -->
{% extends 'base.html' %} 
{% load crispy_forms_tags %}
{% block body %}
<div class="mx-auto">
  <div class="form-group">
    <form action="" method="post">
      {% csrf_token %} 
      {{ form|crispy }}
      <button type="submit" class="btn btn-danger w-100 my-3">Create account</button>
    </form>
  </div>
  {% comment %}  Already Registered {% endcomment %}
  <div class="text-center w-100">
    <p class="text-muted font-weight-bold">
      Already Registered?
      <a href="{% url 'user:login' %}" class="text-primary ml-2"> Login </a>
    </p>
  </div>
</div>
{% endblock body %}